;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Hot Angles ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Compile with FASM
; Version 0.3.3: Sep 25, 2018

; Copyright (c) 2018, Efremenkov Sergey aka TheOnlyMirage
; All rights reserved.
; Redistribution and use in source and binary forms, with or without modification,
; are permitted provided that the following conditions are met:
;    * Redistributions of source code must retain the above copyright notice, this
;    list of conditions and the following disclaimer.
;    * Redistributions in binary form must reproduce the above copyright  notice,
;    this list of conditions and the following disclaimer in the documentation and/or
;    other materials provided with the distribution.
;    * Neither the name of the <organization> nor the names of its contributors may
;    be used to endorse or promote products derived from this software without
;    specific prior written permission.

; THE SOFTWARE IS PROVIDED AS IS, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
; INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
; PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
; HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
; OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
; SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
; --------------------------------------------------------------------------------------

format binary as "" ;"kex"
use32
org 0x0    ;    ,  0x0

UNLOCKd = 0
LOCKd = 1

; 
db 'MENUET01'     ; 
dd 0x01           ;
dd START_DEBUG          ;   
dd I_END          ; ,     
dd 0x100000       ; -    
dd 0x7fff0        ;   esp -             
dd 0, 0           ;        


include '../../macros.inc'

START_DEBUG:
   call copyKill         ;    
   mcall  68, 11         ; 
   call loadConfig       ;  
   mov ebx, 00000100000000000000000000100000b ;    
   mcall 40

START:
  mov     eax, 10                 ; function 10 : wait until event
  mcall                           ; event type is returned in eax

  cmp   eax, 6           ;    
  je    mouse

  jmp START

mouse:
  ;  
  call get_mouse_pos ;   

  cmp eax, 0 ;  
  jne @f
  ; --   .       (X=0, Y=0)
  push ecx
  mov ecx, 0
  call run_command
  pop ecx

  jmp START ;finish
@@:
  call get_screen_size ;   

  cmp ax, word[screen.height]    ;Ymouse = Yscreen ?
  je Ytrue
  ; Y  ,    Y=0  X=ScreenWidth (  )

  cmp ax, 0
  jne unlockend
  shr eax, 16
  cmp ax, word[screen.width]
  jne unlockend
  ; --      
  push ecx
  mov ecx, 2
  call run_command
  pop ecx

  jmp START
Ytrue:
  ; Y ,    X=0 (  )  X=ScreenWidth ( )
  shr eax, 16
  cmp ax, 0
  jne @f
  ; -- X=0, Y = Height  (  )
  push ecx
  mov ecx, 1
  call run_command
  pop ecx
  jmp START
@@:
  cmp ax, word[screen.width]
  jne unlockend
  ; -- (  )
  push ecx
  mov ecx, 3
  call run_command
  pop ecx

  jmp START

unlockend:
  mov byte[state], UNLOCKd
  jmp START


;     
screen:
   .width  dw 0
   .height dw 0
;  
get_screen_size:
   push eax
   mcall 14
   ;  eax = [xsize]*65536 + [ysize]
   ;mov dword[screen], eax
   mov word[screen.height], ax
   shr eax, 16
   mov word[screen.width], ax
   pop eax
   ret


;  
get_mouse_pos:
   ;push eax
   push ebx
   mcall 37, 0
   pop ebx
   ;pop eax
   ret


; : ecx -  : lu=0, ld=1, ru=2, rd=3
run_command:
   cmp byte[state], UNLOCKd
   jne run_command.end

   push eax
   push ebx
   push ecx


   cmp ecx, 0
   jne @f
   mov eax, dword[newData.lu] ;testData.lu
   mov dword[struct70.path_adr], eax
   jmp .end_set_path
@@:
   cmp ecx, 1
   jne @f
   mov eax, dword[newData.ld]
   mov dword[struct70.path_adr], eax
   jmp .end_set_path
@@:
   cmp ecx, 2
   jne @f
   mov eax, dword[newData.ru]
   mov dword[struct70.path_adr], eax
   jmp .end_set_path
@@:
   cmp ecx, 3
   jne .end_set_path
   mov eax, dword[newData.rd]
   mov dword[struct70.path_adr], eax
   jmp .end_set_path
.end_set_path:

   ;
   ;mov dword[struct.adr],

;  0,    
   cmp dword[struct70.path_adr], 0
   jne .next
   ;mov eax, testData.ld
   ;mov dword[struct70.path_adr], eax
   jmp @f
.next:
;   

   mcall 70, struct70
@@:
   mov byte[state], LOCKd

   pop ecx
   pop ebx
   pop eax
.end:
   ret

struct70: ;  
  .func       dd 7 ;  
  .mask       dd 0
  .param_adr  dd 0 ;   ASCIIZ-  
  .other      dd 0, 0
  .path       db 0 ; "/rd/1/TINYPAD",0 ; 
  .path_adr   dd 0 ;testData.lu


state: db 0 ; 0=unlock, 1=lock
mode: db 0  ;  (   )

;testData:
;  .lu db '/rd/1/SHELL', 0
;  .ld db '/rd/1/RUN', 0
;  .ru db "/rd/1/TINYPAD", 0
;  .rd db '/rd/1/File Managers/EOLITE', 0

newData:  ;   
  .lu dd 0
  .ld dd 0
  .ru dd 0
  .rd dd 0
newDataEnd:

;  
fileName: db 'SETTINGS/HOTANGLES.CFG', 0

loadConfig:
   push eax ebx ecx edx
   mcall 68, 27, fileName   ;    
   cmp eax, 0
   je loadConfig.exit       ;   ,    
   ;    ,   edx
   cmp edx, 0               ;  ,    ,   
   je loadConfig.exit

   add edx, eax             ;   edx -   

   cmp byte[eax], 121 ;'y'  ;     :  
   jne loadConfig.exit      ;   

   push edi
   push esi
   ;   edi       
   mov edi, newData
   ;      0  
   mov esi, eax
.block:
   inc esi
   cmp byte[esi], 10         ;    10  13,   
   je loadConfig.propusk     ;    
   cmp byte[esi], 13
   je loadConfig.propusk

   ;         -     ,   
   mov dword[edi], esi
   add edi, 4

   ;    :     10, 13, 0  file end
.while:
   inc esi
   cmp esi, edx           ;   -   ,     !!! 
   jae loadConfig.fileend
   cmp byte[esi], 10
   je loadConfig.ura
   cmp byte[esi], 0
   je loadConfig.ura
   cmp byte[esi], 13
   jne loadConfig.while
.ura:
   mov byte[esi], 0

   ;cmp byte[esi-1], '-'
   ;jne @f
   push esi  ;    ,     
   mov esi, dword[edi-4]
   cmp byte[esi], '-'
   jne @f
   cmp byte[esi+1], 0
   jne @f
   mov dword[edi-4], 0
@@:
   pop esi

   cmp edi, newDataEnd ;newData.end      ;    ,    
   jb loadConfig.block
.fileend:

   pop esi
   pop edi

   jmp loadConfig.end

.propusk:
   mov byte[esi], 0
   jmp loadConfig.block
.exit:
   pop edx ecx ebx eax
   mcall -1 ;  
.end:
   pop edx ecx ebx eax
   ret




;      
selfName db '@HOTANGLES',0
selfNameSize = 10 ; 11 byte
;
compareBytes:
   push edi esi ecx ebx
   mov eax, 0 ;xor eax, eax
   mov ecx, selfNameSize    ;max   11
@@:
   mov bl, byte[edi]
   cmp bl, byte[esi]
   jne compareBytes.no
   inc edi
   inc esi
   cmp ecx, 0
   je @f
   dec ecx
   jmp @b
.no:
   mov eax, 1
@@:
   pop ebx ecx esi edi
   ret
;
slotMax dd 0
selfPID dd 0
buf db 1024 dup(0)
copyKill:
   push eax ebx ecx esi edi

   ;   
   mcall 9, buf, -1
   mov eax, dword[buf+30]
   mov dword[selfPID], eax

   ;,    :
   mov esi, selfName       ;  -   
   mov edi, buf            ;  -   
   add edi, 10

   mov ecx, 1
@@:
   mcall 9, buf, ecx
   mov dword[slotMax], eax

   ;   ,   
   mov eax, dword[buf+30]
   cmp eax, dword[selfPID]
   je copyKill.propusk

   call compareBytes   ; 11  ,   eax

   cmp eax, 0
   je copyKill.selfKill

.propusk:
   inc ecx
   cmp ecx, dword[slotMax]
   ja @f
   jmp @b

.selfKill:
   pop edi esi ecx ebx eax
   mcall -1
   ret
@@:
   pop edi esi ecx ebx eax
   ret



I_END:
